# SPDX-FileCopyrightText: 2022 Dimitris Kardarakos <dimkard@posteo.net>
# SPDX-License-Identifier: GPL-3.0-or-later

import pytest
from glossaico.skill_model import SkillModel


@pytest.fixture(name="not_loaded_skill_model")
def fixture_not_loaded_skill_model():
    return SkillModel(None, None)


def test_skillId_inp_not_loaded_model_out_error(not_loaded_skill_model):
    with pytest.raises(RuntimeError):
        print(not_loaded_skill_model.skillId)


def test_displayName_inp_not_loaded_model_out_error(not_loaded_skill_model):
    with pytest.raises(RuntimeError):
        print(not_loaded_skill_model.displayName)


def test_words_inp_not_loaded_model_out_error(not_loaded_skill_model):
    with pytest.raises(RuntimeError):
        print(not_loaded_skill_model.words)


def test_phrases_inp_not_loaded_model_out_error(not_loaded_skill_model):
    with pytest.raises(RuntimeError):
        print(not_loaded_skill_model.phrases)


def test_name_inp_not_loaded_model_out_error(not_loaded_skill_model):
    with pytest.raises(RuntimeError):
        print(not_loaded_skill_model.name)


def test_courseName_inp_not_loaded_model_out_error(not_loaded_skill_model):
    with pytest.raises(RuntimeError):
        print(not_loaded_skill_model.courseName)


def test_progress_inp_not_loaded_model_out_error(not_loaded_skill_model):
    with pytest.raises(RuntimeError):
        print(not_loaded_skill_model.progress)


def test_challenges_inp_not_loaded_model_out_error(not_loaded_skill_model):
    with pytest.raises(RuntimeError):
        print(not_loaded_skill_model.challenges)


def test_needsReview_inp_not_loaded_model_out_error(not_loaded_skill_model):
    with pytest.raises(RuntimeError):
        print(not_loaded_skill_model.needsReview)


def test_challengesPassed_inp_not_loaded_model_out_error(not_loaded_skill_model):
    with pytest.raises(RuntimeError):
        print(not_loaded_skill_model.challengesPassed)
